
#include <omp.h>
#include <stdio.h>

#define N 12

int main (int argc, char *argv[]) {
  int a[N][N], b[N][N], c[N][N], i, j, k;

  omp_set_num_threads(4);

  // initialize a and b
  for (i = 0; i < N; i++) { 
    for (j = 0; j < N; j++) {
      a[i][j] = i+j;
      b[i][j] = i == j; // identity matrix
    }
  }
    
  // Compute c = a * b
  for (i = 0; i < N; i++) {
    for(j = 0; j < N; j++) {       
      c[i][j] = 0;
      for (k = 0; k < N; k++) {
        c[i][j] += a[i][k] * b[k][j];
      }
    }
  }

  // Print result
  printf("***********************************************************\n");
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) printf("%d ", c[i][j]);
    putchar('\n'); 
  }
  printf("***********************************************************\n");
  return 0;
}

